const { Enum } = require("gutsypackage")

function IsAvailableHours(availableHours) {

  if(!availableHours) return true

  if(typeof(availableHours) !== "object") return false
  
  const allWeekHourValues = Enum.WeekHour.allValues()

  for(const p in availableHours) {
    if(!allWeekHourValues.includes(p)) {
      return false
    }
    const val = availableHours[p]
    if((val+"").length > 'false'.length) {
      return false
    }
  }
  return true
}

const WeekHourValidator = {
  IsAvailableHours
}

module.exports = {
  WeekHourValidator
}